#include <stdio.h>
#include <ldap.h>


#define LDHOST "aga.npac.syr.edu"
#define LDPORT 1389

/* #define SEARCHBASE "cn=Tomasz Haupt, ou=Gateway, o=npac.syr.edu" */

/* #define SEARCHBASE "o=Lawrence Berkeley National Laboratory, c=US" */
#define SEARCHBASE "o=npac.syr.edu, c=US"

main()
{
    LDAP    *ld;
    LDAPMessage *result, *e;
    BerElement  *ber;
    /*    int nentries;  */
    char    *a, *dn;
    char    **vals;
    int     i;

    if ( (ld = ldap_init( LDHOST, LDPORT )) == NULL) {
        perror( "ldap_init" );
        exit( 1 );
    } 
    
    if ( ldap_simple_bind_s( ld, NULL, NULL) != LDAP_SUCCESS) {
      ldap_perror( ld, "ldap_simple_bind_s" );
      exit( 1 );
    }

    if ( ldap_search_s( ld, SEARCHBASE, LDAP_SCOPE_SUBTREE, "(objectclass=*)", NULL, 0, &result) != LDAP_SUCCESS) {
      ldap_perror( ld, "ldap_search_s" );
      printf("Something is wrong for LDAP search!!!\n");
      exit( 1 );
    }

    /*    if ( (nentries = ldap_count_entries( ld, result )) == -1 ) {
      ldap_perror( ld, "ldap_count_entries" );
      exit( 1 );
    } */

    for ( e = ldap_first_entry( ld, result ); e != NULL;
          e = ldap_next_entry( ld, e)) {
      if ( (dn = ldap_get_dn(ld,e)) != NULL) {
        printf("dn: %s\n", dn);
        ldap_memfree( dn );
      }

      for( a = ldap_first_attribute( ld, e, &ber);
           a != NULL; a = ldap_next_attribute( ld, e, ber)) {
        if ( (vals = ldap_get_values( ld, e, a)) != NULL) {
          for ( i = 0; vals[i] != NULL; i++) {
            printf("%s: %s\n", a, vals[i] );
          }
          ldap_value_free( vals );
        }
        ldap_memfree( a );
      }
      if ( ber != NULL ) {
        ber_free( ber,0 );
      }
      printf("\n");
    }
    ldap_msgfree( result );
    ldap_unbind( ld );
    return (0);
}

